## pymvpa2 2.6.0

=== debian/changelog ===
pymvpa2 (2.6.0-1~nd70+1) wheezy; urgency=medium

  * Backported for wheezy.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Fri, 26 Aug 2016 23:42:49 -0400

pymvpa2 (2.6.0-1) unstable; urgency=medium

  * Fresh upstream release
    - variety of bugfixes, e.g. compatibility with scipy 0.17.1, nibabel 2.1
  * debian/control
    - policy boost to 3.9.8

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 26 Aug 2016 20:21:05 -0400

=== debian/control ===
Source: pymvpa2
Section: python
Priority: optional
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian team <team@neuro.debian.net>
Uploaders: Michael Hanke <mih@debian.org>, Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7.0.50~),
               python-all-dev (>= 2.6.6-3~),
               swig | swig2.0,
               python-numpy, python-scipy,
               python-nibabel,
               python-nose,
               python-h5py,
               python-lxml,
               libsvm-dev (>= 2.84.0),
               help2man, man2html,
               python-sphinx, python-numpydoc,
               graphviz, inkscape, imagemagick, bc,
               python-matplotlib,
               python-statsmodels [!s390x],
               python-joblib
Standards-Version: 3.9.8
Homepage: http://www.pymvpa.org
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/pymvpa.git
Vcs-Git: git://git.debian.org/git/pkg-exppsy/pymvpa.git -b dist2/debian/proper/sid
X-Python-Version: >= 2.7


Package: python-mvpa2
Architecture: all
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${python:Depends},
         python-mvpa2-lib(>= ${source:Version}),
         python-numpy,
Recommends:
         python-h5py,
         python-lxml,
         python-matplotlib,
         python-mdp,
         python-nibabel,
         python-nipy,
         python-psutil,
         python-psyco,
         python-pywt,
         python-reportlab,
         python-scipy,
         python-sklearn,
         python-shogun,
         liblapack-dev,
         python-pprocess,
         python-statsmodels,
         python-joblib,
         python-duecredit,
Suggests:
         fslview, fsl,
         python-mvpa2-doc,
         python-nose,
         python-openopt,
         python-rpy2,
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: multivariate pattern analysis with Python v. 2
 PyMVPA eases pattern classification analyses of large datasets, with an
 accent on neuroimaging. It provides high-level abstraction of typical
 processing steps (e.g. data preparation, classification, feature selection,
 generalization testing), a number of implementations of some popular
 algorithms (e.g. kNN, Ridge Regressions, Sparse Multinomial Logistic
 Regression), and bindings to external machine learning libraries (libsvm,
 shogun).
 .
 While it is not limited to neuroimaging data (e.g. fMRI, or EEG) it
 is eminently suited for such datasets.
 .
 This is a package of PyMVPA v.2.  Previously released stable version
 is provided by the python-mvpa package.


Package: python-mvpa2-lib
Architecture: any
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}, ${python:Depends},
         python-numpy
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: low-level implementations and bindings for PyMVPA v. 2
 This is an add-on package for the PyMVPA framework. It provides a low-level
 implementation of an SMLR classifier and custom Python bindings for the LIBSVM
 library.
 .
 This is a package of a development snapshot. The latest released version is
 provided by the python-mvpa-lib package.


Package: python-mvpa2-doc
Architecture: all
Section: doc
Depends: neurodebian-popularity-contest, ${misc:Depends}, libjs-jquery, libjs-underscore
Suggests: python-mvpa2, python-mvpa2-tutorialdata, ipython-notebook
Description: documentation and examples for PyMVPA v. 2
 This is an add-on package for the PyMVPA framework. It provides a
 HTML documentation (tutorial, FAQ etc.), and example scripts.
 In addition the PyMVPA tutorial is also provided as IPython notebooks.

## pymvpa2 2.6.1

=== debian/changelog ===
pymvpa2 (2.6.1-1~nd15.04+1) vivid; urgency=medium

  * Backported for vivid.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Thu, 20 Apr 2017 13:15:41 -0400

pymvpa2 (2.6.1-1) experimental; urgency=medium

  * Fresh upstream (primarily minor bugfix) release
    - python-mock into build-depends
  * debian/rules
    - invoke tests via  python -m nose  since otherwise lead to some
      weird infinite recursions etc

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 20 Apr 2017 11:24:40 -0400

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,8 @@
                graphviz, inkscape, imagemagick, bc,
                python-matplotlib,
                python-statsmodels [!s390x],
-               python-joblib
+               python-joblib,
+               python-mock,
 Standards-Version: 3.9.8
 Homepage: http://www.pymvpa.org
 Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/pymvpa.git
@@ -50,6 +51,7 @@
          python-statsmodels,
          python-joblib,
          python-duecredit,
+         python-mock,
 Suggests:
          fslview, fsl,
          python-mvpa2-doc,

## pymvpa2 2.6.3

=== debian/changelog ===
pymvpa2 (2.6.3-1~nd16.10+1) yakkety; urgency=medium

  * Backported for yakkety.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Fri, 03 Nov 2017 03:20:37 -0400

pymvpa2 (2.6.3-1) unstable; urgency=medium

  * Fresh bugfix release -- primarily just tests

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 03 Nov 2017 00:47:56 -0400

pymvpa2 (2.6.2-1) unstable; urgency=medium

  * Fresh upstream bugfix release
    - dropping all debian/patches/00* picked up from upstream

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 01 Nov 2017 00:06:43 -0400

pymvpa2 (2.6.1-2) unstable; urgency=medium

  * Upload to unstable
  * debian/patches/00* 
    - addressing for changes in sphinx
    - addressing for more strict numpy 1.13.1
  * debian/control
    - boosted policy to 4.0.0
    - boosted compat/debhelper to 9
    - added dh-python to build-depends

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 17 Oct 2017 22:53:34 -0400

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
 X-Original-Maintainer: NeuroDebian team <team@neuro.debian.net>
 Uploaders: Michael Hanke <mih@debian.org>, Yaroslav Halchenko <debian@onerussian.com>
-Build-Depends: debhelper (>= 7.0.50~),
+Build-Depends: debhelper (>= 9~),
+               dh-python,
                python-all-dev (>= 2.6.6-3~),
                swig | swig2.0,
                python-numpy, python-scipy,
@@ -20,7 +21,7 @@
                python-statsmodels [!s390x],
                python-joblib,
                python-mock,
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://www.pymvpa.org
 Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/pymvpa.git
 Vcs-Git: git://git.debian.org/git/pkg-exppsy/pymvpa.git -b dist2/debian/proper/sid

## pymvpa2 2.6.4

=== requirements.txt ===
# should be present but installing via pip might be too lengthy
# numpy
# scipy
# sklearn
duecredit
nibabel
# not compatible ATM with python3
# pprocess
# Some parts use it already
joblib

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
PYTHON        = python
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

export SHELL=/bin/bash

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR) source/generated source/intersphinx
	-rm generate-stamp

SPHINXEXT_PATH=$(shell python -c 'import sphinx.ext; from distutils.version import LooseVersion; print LooseVersion(sphinx.__version__) < "1.1.2" and "sphinxext" or sphinx.ext.__path__[0]')
#SPHINXEXT_PATH=sphinxext

generate: generate-stamp
generate-stamp: cache_intersphinx
	mkdir -p $(BUILDDIR)
	mkdir -p source/generated
	set -e; set -o pipefail; for man in $(BUILDDIR)/man/pymvpa*; do \
		manfile=$$(basename $${man}) ; \
		cmd=$${manfile#pymvpa2-*} ; \
		cmd=$${cmd%*.1} ; \
		man2html $${man} | sed -n '/<HR>/{:a;n;/<HR>/b;p;ba}' | sed -n '/<A NAME/{:a;n;/This document was created by/b;p;ba}' > source/generated/$${manfile}.html ; \
		underline="*****************$$(echo $${cmd} | tr A-Za-z0-9 \*)" ; \
		printf ".. index:: command line, $${cmd}\n.. _chap_cmdline_$${cmd}:\n\n$${underline}\nMan page for \`\`$${cmd}\`\`\n$${underline}\n\n.. raw:: html\n   :file: $${manfile}.html\n" > source/generated/cmd_$${cmd}.rst ; \
	done
	@touch $@

cache_intersphinx: cache_intersphinx-stamp
cache_intersphinx-stamp:
	# fetch intersphinx objects for explicit intersphinxing
	python source/conf.py cache_intersphinx
	@touch $@

html: generate
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: generate
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle: generate
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: generate
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: generate
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: generate
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PyMVPA.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PyMVPA.qhc"

latex: generate
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes: generate
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck: generate
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest: generate
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== tools/Makefile ===
TARGETS=pdfbook
TDIR=../build/tools

all: $(TARGETS)

pdfbook:
	mkdir -p $(TDIR)
	gcc pdfbook.c -o $(TDIR)/pdfbook

clean::
	rm -f $(TDIR)/pdfbook

=== debian/changelog ===
pymvpa2 (2.6.4-2) unstable; urgency=medium

  * patches to fortify scatter code and tests against degenerate cases which
    reveal themselves on exotic platforms (Now should really Closes: #880793).
    ref: https://github.com/numpy/numpy/issues/10496

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 31 Jan 2018 11:09:23 -0500

pymvpa2 (2.6.4-1) unstable; urgency=medium

  * Fresh upstream bugfix release
  * Manually create simple smlrc.so and svmc.so symlinks to multiarch .so.
    Apparently numpy.ctypeslib.load_library is not creating a valid multiarch
    suffix to match the one created by dh_python2
  * debian/rules
    - run tests under fixed MVPA_SEED=1 to avoid surprises, so should
      resolve spurious FTBFS (tried to close #880793)

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 29 Jan 2018 15:15:50 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: pymvpa2
 Section: python
 Priority: optional
-Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
-X-Original-Maintainer: NeuroDebian team <team@neuro.debian.net>
+Maintainer: NeuroDebian team <team@neuro.debian.net>
 Uploaders: Michael Hanke <mih@debian.org>, Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends: debhelper (>= 9~),
                dh-python,
@@ -30,7 +29,7 @@
 
 Package: python-mvpa2
 Architecture: all
-Depends: neurodebian-popularity-contest, ${misc:Depends}, ${python:Depends},
+Depends: ${misc:Depends}, ${python:Depends},
          python-mvpa2-lib(>= ${source:Version}),
          python-numpy,
 Recommends:
@@ -79,7 +78,7 @@
 
 Package: python-mvpa2-lib
 Architecture: any
-Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}, ${python:Depends},
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends},
          python-numpy
 Provides: ${python:Provides}
 XB-Python-Version: ${python:Versions}
@@ -95,7 +94,7 @@
 Package: python-mvpa2-doc
 Architecture: all
 Section: doc
-Depends: neurodebian-popularity-contest, ${misc:Depends}, libjs-jquery, libjs-underscore
+Depends: ${misc:Depends}, libjs-jquery, libjs-underscore
 Suggests: python-mvpa2, python-mvpa2-tutorialdata, ipython-notebook
 Description: documentation and examples for PyMVPA v. 2
  This is an add-on package for the PyMVPA framework. It provides a

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
upstreamver = $(shell echo $(debver) | sed -e 's/-[^-]*$$//' )

# this figures out the last merge point from 'master' into the 'dist' branch and
# then described this commit relative to the last release tag (upstream/...)
# If this should make any sense the local master branch must track remote
# master.
gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'upstream/*' $$(git merge-base -a HEAD master) | sed -e 's,^upstream/,,' -e 's/\.dev/~dev/' -e 's/\.rc/~rc/')

export HOME=$(CURDIR)/build
# so we could use custom symlinked swig2.0
export PATH:=$(PATH):$(HOME)

# one ring to rule them all ...
%:
# need to enforce distutils, since we also have a makefile
	dh $@ --with=python2 --buildsystem=python_distutils --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure
	mkdir -p $(CURDIR)/build
	cp -rp debian/intersphinx doc/source/
	which swig >/dev/null || ln -s /usr/bin/swig2.0 $(CURDIR)/build/swig

override_dh_auto_build:
	dh_auto_build -- --with-libsvm
	$(MAKE) manpages
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	http_proxy=http://127.0.0.1:9/ https_proxy=http://127.0.0.1:9/ \
		$(MAKE) htmldoc
	-rm build/html/_static/jquery.js build/html/_static/underscore.js
	$(MAKE) notebooks
endif


# we run the test suite on the install
override_dh_auto_test:
	: # Tests will be ran later on against installed version

override_dh_auto_install:
	dh_auto_install -- --with-libsvm
	# run unit tests here to actually check the deployed package
	# whenever we don't have to build for python 2.5 anymore call
	# python with -B and remove the find for pyc files
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	for buildver in $(shell pyversions -vr); do \
		echo "I: Running PyMVPA unittests using python$$buildver"; \
		cd $(CURDIR)/debian/tmp/usr/lib/python$$buildver/*-packages && \
        MVPA_SEED=1 \
		PYTHONPATH=. MVPA_TESTS_LABILE=no MVPA_TESTS_LOWMEM=yes \
		MVPA_TESTS_QUICK=yes MVPA_TESTS_VERBOSITY=3 MVPA_MATPLOTLIB_BACKEND=agg \
		python$$buildver -m nose -s -v mvpa2 \
		|| exit 1 ; find . -type f -name '*.pyc' -delete ; \
	done
endif
	# and now move libraries into -lib package (account for snapshot name
	# as well)
	mkdir -p $(CURDIR)/debian/python-mvpa2-lib
	cd $(CURDIR)/debian/python-mvpa2-lib && \
		for so in $$(find ../tmp -name '*.so'); do \
			install -D $$so $${so#../tmp/*} ; \
			rm $$so ; \
		done
	: # Do not install some existing scripts yet for now
	find debian -wholename '*/bin/*' -o -wholename '*/man/*' \
	| grep -e 'pymvpa2-\(analysis\)' \
	| xargs -r rm -rf

override_dh_python2:
	dh_python2
	if [ -x /usr/bin/dh_numpy ]; then dh_numpy; fi
	# Create a symlink to fix up for dh_python2 creating arch-specific
	# libs, while numpy not understanding those for python2:
	# https://github.com/PyMVPA/PyMVPA/issues/568
	/usr/bin/find debian/python-mvpa2*lib -iname *.so \
	| while read so; do \
		bso=$$(basename $$so); dso=$$(dirname $$so); \
		tso=$$dso/$${bso%%.*}.so; \
		[ -e "$$tso" ] || ln -sf $$bso $$tso ;\
	done

override_dh_installchangelogs:
	dh_installchangelogs Changelog

override_dh_auto_clean:
	$(MAKE) clean
	dh_auto_clean
	-rm -rf $(CURDIR)/build

# make orig tarball from repository content
get-orig-source:
	# orig tarball, turn directory into something nicer
	git archive --format=tar --prefix=$(srcpkg)-$(gitver)/ HEAD | \
		tar --delete $(srcpkg)-$(gitver)/debian | \
		gzip -9 > $(srcpkg)_$(gitver).orig.tar.gz

# same for dev snapshots, but here it produces a dev changelog entry first
# that converts the source package name to -snapshot
dev-source: dev-changelog get-orig-source
	mv $(srcpkg)_$(gitver).orig.tar.gz ..

# helper to create a new changelog entry for a development snapshot package
# go with default changelog item for each new snapshot, but fire up editor
# if there already was a changelog for this upstream version, as there is
# probably something to say about this new Debian snapshot package release
dev-changelog:
	@if [ "$(gitver)" = "$(upstreamver)" ]; then \
		dch -i --package pymvpa-snapshot ; \
	else \
		dch --newversion $(gitver)-1 --package pymvpa-snapshot \
			--allow-lower-version "PyMVPA development snapshot." ; \
	fi

## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -Xobjects.inv -X.ipynb -X.sh

cache_intersphinx:
	rm -rf debian/intersphinx
	-rm doc/cache_intersphinx-stamp
	make
	PYTHONPATH=$(CURDIR) make -C doc cache_intersphinx
	mv doc/source/intersphinx debian/

=== debian/watch ===
version=3
opts="filenamemangle=s/.*\/(.*)/pymvpa2-$1/,uversionmangle=s/rc/~rc/g" \
 https://github.com/PyMVPA/PyMVPA/tags .*archive/upstream/([\d\.a-z]+)\.tar\.gz

## pymvpa2 2.6.5

=== Makefile ===
PROFILE_FILE=$(CURDIR)/$(BUILDDIR)/main.pstats
COVERAGE_REPORT=$(CURDIR)/$(BUILDDIR)/coverage
BUILDDIR=$(CURDIR)/build
BUILD3DIR=$(CURDIR)/build/py3k
HTML_DIR=$(BUILDDIR)/html
DOC_DIR=$(CURDIR)/doc
TUT_DIR=$(CURDIR)/datadb/tutorial_data/tutorial_data
DOCSRC_DIR=$(DOC_DIR)/source
DOCBUILD_DIR=$(BUILDDIR)/doc
NOTEBOOKBUILD_DIR=$(HTML_DIR)/notebooks
MAN_DIR=$(BUILDDIR)/man
APIDOC_DIR=$(HTML_DIR)/api
PDF_DIR=$(BUILDDIR)/pdf
LATEX_DIR=$(BUILDDIR)/latex
WWW_DIR=$(BUILDDIR)/website
SWARM_DIR=$(BUILDDIR)/swarm
WWW_UPLOAD_URI=www.pymvpa.org:/home/www/www.pymvpa.org/pymvpa
WWW_UPLOAD_URI_DEV=dev.pymvpa.org:/home/www/dev.pymvpa.org/pymvpa
DATA_HOST=data.pymvpa.org
DATA_DIR=datadb
DATA_SUBDIRS='$(DATA_DIR)/tutorial_data \
                  $(DATA_DIR)/mnist \
                  $(DATA_DIR)/face_inversion_demo \
                  $(DATA_DIR)/hyperalignment_tutorial_data \
                  $(DATA_DIR)/haxby2001'
DATA_UPLOAD_URI=$(DATA_HOST):/home/www/data.pymvpa.org/www/datasets
SWARMTOOL_DIR=tools/codeswarm
SWARMTOOL_DIRFULL=$(CURDIR)/$(SWARMTOOL_DIR)
RSYNC_OPTS=-az -H --no-perms --no-owner --verbose --progress --no-g --exclude prev/
RSYNC_OPTS_UP=-rzlhv --delete
# -p --chmod=Dg+s,g+rw,o+rX

#
# The Python executable to be used
#
PYTHON = python
PYTHON3 = python3

# Setup local PYTHONPATH depending on the version of provided $(PYTHON)
PYVER = $(shell $(PYTHON) -c 'import sys; print(sys.version_info[0])')
ifeq ($(PYVER),2)
 # just use the local sources and run tests 'in source'
 TEST_DIR = .
 LPYTHONPATH = .:$(PYTHONPATH)
else
 # for 3 (and hopefully not above ;) ) -- corresponding build/
 # since sources go through 2to3 conversion
 TEST_DIR = $(BUILD3DIR)
 LPYTHONPATH = $(BUILD3DIR):$(PYTHONPATH)
endif

# Assure non-interactive Matplotlib and provide local paths helper
MPLPYTHONPATH = PYTHONPATH=.:$(LPYTHONPATH) MVPA_MATPLOTLIB_BACKEND=agg
MPLPYTHON = $(MPLPYTHONPATH) $(PYTHON)
MPLPYTHON3 = $(MPLPYTHONPATH) $(PYTHON3)

NOSETESTS = $(PYTHON) $(shell which nosetests)

#
# Helpers for version handling.
# Note: can't be ':='-ed since location of invocation might vary
DEBCHANGELOG_VERSION = $(shell dpkg-parsechangelog | egrep ^Version | cut -d ' ' -f 2,2 | cut -d '-' -f 1,1)
SETUPPY_VERSION = $(shell $(PYTHON) setup.py -V)

#
# Automatic development version
#
#yields: LastTagName_CommitsSinceThat_AbbrvHash
DEV_VERSION := $(shell git describe --abbrev=4 HEAD |sed -e 's/-/+/g' |cut -d '/' -f 2,2)

# By default we are releasing with setup.py version
RELEASE_VERSION ?= $(SETUPPY_VERSION)
RELEASE_CODE ?=

# Conditional depends regulated from outside
#
ifdef PYMVPA_NO_3RD
	build_depends :=
else
	build_depends :=
endif

#
# Details on the Python/system
#

PYVER := $(shell $(PYTHON) -V 2>&1 | cut -d ' ' -f 2,2 | cut -d '.' -f 1,2)

#
# Little helpers
#

mkdir-%:
	if [ ! -d $($*) ]; then mkdir -p $($*); fi


#
# Building
#

all: build

# build included 3rd party pieces (if present)
3rd: 3rd-stamp
3rd-stamp:
	find 3rd -mindepth 1 -maxdepth 1  -type d | \
	 while read d; do \
	  [ -f "$$d/Makefile" ] && $(MAKE) -C "$$d" || :; \
     done
	touch $@


debian-build:
# reuse is better than duplication (yoh)
	debian/rules build


build: build-stamp
build-stamp: $(build_depends)
	$(PYTHON) setup.py config --noisy
	$(PYTHON) setup.py build_ext --inplace
	touch $@

build3: build3-stamp
build3-stamp: $(build_depends)
	$(PYTHON3) setup.py config --noisy
	$(PYTHON3) setup.py build_ext --inplace
	touch $@

#
# Cleaning
#

# this target is used to clean things for a fresh build
clean:
	@echo "I: Performing clean operation"
# clean 3rd party pieces
	find 3rd -mindepth 1 -maxdepth 1  -type d | \
	 while read d; do \
	  [ -f "$$d/Makefile" ] && $(MAKE) -C "$$d" clean || : ; \
     done
# clean tools
	$(MAKE) -C tools clean
# clean pics
	$(MAKE) -C doc/pics clean
# clean docs
	$(MAKE) -C doc clean
	-@rm -f $(DOCSRC_DIR)/examples/*.rst
	-@rm -f $(DOCSRC_DIR)/cmdline/*.rst
# clean all bits and pieces
	-@rm -f MANIFEST
	-@rm -f mvpa2/clfs/lib*/*.so \
		mvpa2/clfs/lib*/*.dylib \
		mvpa2/clfs/lib*/*_wrap.* \
		mvpa2/clfs/lib*/*c.py \
		mvpa2/tests/*.{prof,pstats,kcache}
	@find . -name '*.py[co]' \
		 -o -name '*,cover' \
		 -o -name '.coverage' \
		 -o -name 'iterate.dat' \
		 -o -iname '*~' \
		 -o -iname '*.kcache' \
		 -o -iname '*.gch' \
		 -o -iname '*_flymake.*' \
		 -o -iname '#*#' | xargs -L 10 rm -f
	-@rm -rf build
	-@rm -rf dist *report __pycache__
	-@rm -f *-stamp *_report.pdf *_report.log pymvpa2.cfg

# this target should put the source tree into shape for building the source
# distribution
distclean: clean
# if we are on debian system - we might have left-overs from build
	-@$(MAKE) debian-clean
	-@rm -rf tools/codeswarm



debian-clean:
# remove stamps for builds since state is not really built any longer
	-fakeroot debian/rules clean


#
# Documentation
#

doc: website manpages

pics:
	$(MAKE) -C doc/pics

manpages: mkdir-MAN_DIR
	@echo "I: Creating manpages"
	PYTHONPATH=$(LPYTHONPATH) help2man -N -n 'preprocess fMRI data for PyMVPA' \
		bin/pymvpa2-prep-fmri > $(MAN_DIR)/pymvpa2-prep-fmri.1
	PYTHONPATH=$(LPYTHONPATH) help2man -N -n 'start a PyMVPA tutorial session' \
		bin/pymvpa2-tutorial > $(MAN_DIR)/pymvpa2-tutorial.1
	PYTHONPATH=$(LPYTHONPATH) help2man --no-discard-stderr -N -n \
			'preprocess FreeSurfer surfaces for AFNI/SUMA' \
			bin/pymvpa2-prep-afni-surf > $(MAN_DIR)/pymvpa2-prep-afni-surf.1
	PYTHONPATH=$(LPYTHONPATH) help2man --no-discard-stderr \
		--help-option="--help-np" -N -n "command line interface for PyMVPA" \
			bin/pymvpa2 > $(MAN_DIR)/pymvpa2.1
	for cmd in $$(tr "\n'," ' ' < bin/pymvpa2 | sed -e 's/.*enabled_cmds = \[//' -e 's/\].*//'); do \
		summary="$$(grep 'man: -*-' < mvpa2/cmdline/cmd_$${cmd}.py | cut -d '%' -f 2-)"; \
		PYTHONPATH=$(LPYTHONPATH) help2man --no-discard-stderr \
			--help-option="--help-np" -N -n "$$summary" \
				"bin/pymvpa2 $${cmd}" > $(MAN_DIR)/pymvpa2-$${cmd}.1 ; \
	done

references:
	@echo "I: Generating references"
	tools/bib2rst_ref.py

# Since mpl doesn't take env variables
mpl-stamp: build
	echo "backend : Agg" >| $(CURDIR)/build/matplotlibrc
	touch $@

htmldoc: examples2rst build pics mpl-stamp notebooks manpages
	@echo "I: Creating an HTML version of documentation"
	cd $(DOC_DIR) && MVPA_EXTERNALS_RAISE_EXCEPTION=off \
		PYTHONPATH=$(CURDIR):$(PYTHONPATH) \
		MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build \
		$(MAKE) html BUILDDIR=$(BUILDDIR) SPHINXOPTS="$(SPHINXOPTS)"
	cd $(HTML_DIR)/generated && ln -sf ../_static
	cd $(HTML_DIR)/examples && ln -sf ../_static
	cd $(HTML_DIR)/workshops && ln -sf ../_static
	cd $(HTML_DIR)/datadb && ln -sf ../_static
	cp $(DOCSRC_DIR)/pics/history_splash.png $(HTML_DIR)/_images/
	cp $(DOC_DIR)/pics/*-logo_h*.png $(HTML_DIR)/_static/

pdfdoc: examples2rst build pics pdfdoc-stamp
pdfdoc-stamp: mpl-stamp
	@echo "I: Creating a PDF version of documentation"
	cd $(DOC_DIR) && MVPA_EXTERNALS_RAISE_EXCEPTION=off \
		PYTHONPATH=$(CURDIR):$(PYTHONPATH) \
		MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build \
		$(MAKE) latex BUILDDIR=$(BUILDDIR) SPHINXOPTS="$(SPHINXOPTS)"
	cd $(LATEX_DIR) && $(MAKE) all-pdf
	touch $@

# Create a handy .pdf of the manual to be printed as a book
handbook: pdfdoc
	@echo "I: Creating a handbook of the manual"
	cd tools && $(MAKE) pdfbook
	build/tools/pdfbook -2 \
	 $(LATEX_DIR)/PyMVPA-Manual.pdf $(LATEX_DIR)/PyMVPA-Manual-Handbook.pdf

examples2rst: examples2rst-stamp
examples2rst-stamp: mkdir-DOCBUILD_DIR
	tools/ex2rst \
		--project PyMVPA \
		--outdir $(DOCSRC_DIR)/examples \
		--exclude doc/examples/searchlight_app.py \
		doc/examples
	tools/cmdex2rst \
		--project PyMVPA \
		--outdir $(DOCSRC_DIR)/cmdline/ \
		doc/examples/cmdline
	touch $@

notebooks: notebooks-stamp
notebooks-stamp: examples2rst
	mkdir -p $(NOTEBOOKBUILD_DIR)
	tools/rst2ipnbpy \
		--baseurl http://pymvpa.org/examples \
		--apiref_baseurl http://pymvpa.org/generated \
		--glossary_baseurl http://pymvpa.org/glossary.html \
		--outdir $(NOTEBOOKBUILD_DIR) \
		--exclude doc/source/tutorial_prerequisites.rst \
		--verbose \
		doc/source/tutorial_*.rst doc/source/examples/*.rst
	touch $@

apidoc: apidoc-stamp
apidoc-stamp: build
# Disabled profiling for now, it consumes huge amounts of memory, so I doubt
# that all buildds can do it. In theory it would only be done on a single
# developer machine, because it is only necessary for the arch-all package,
# but e.g. dpkg-buildpackage runs the indep target anyway -- not sure about
# the buildds, though.
#apidoc-stamp: profile
	@echo "I: Creating an API documentation with epydoc"
	mkdir -p $(HTML_DIR)/api
	LC_ALL=C MVPA_EPYDOC_WARNINGS=once tools/epydoc --config doc/api/epydoc.conf
	touch $@

# this takes some minutes !!
# TODO: adjust for py3 compatibility
profile: build mvpa2/tests/__init__.py
	@echo "I: Profiling unittests"
	@PYTHONPATH=$(LPYTHONPATH) tools/profile -K  -O $(PROFILE_FILE) mvpa2/tests/__init__.py


#
# Website
#

website: website-stamp
website-stamp: mkdir-WWW_DIR htmldoc pdfdoc
	cp -r $(HTML_DIR)/* $(WWW_DIR)
	cp $(LATEX_DIR)/PyMVPA-*.pdf $(WWW_DIR)
	tools/sitemap.sh > $(WWW_DIR)/sitemap.xml
# main icon of the website
	cp $(DOCSRC_DIR)/pics/favicon.png $(WWW_DIR)/_images/
# for those who do not care about <link> and just trying to download it
	cp $(DOCSRC_DIR)/pics/favicon.png $(WWW_DIR)/favicon.ico
# provide robots.txt to minimize unnecessary traffic
	cp $(DOCSRC_DIR)/_static/robots.txt $(WWW_DIR)/
# provide promised pylintrc
	mkdir -p $(WWW_DIR)/misc && cp $(DOC_DIR)/misc/pylintrc $(WWW_DIR)/misc
	touch $@

upload-website:
	$(MAKE) website SPHINXOPTS='-D html_theme=pymvpa_online'
	rsync $(RSYNC_OPTS_UP) $(WWW_DIR)/* $(WWW_UPLOAD_URI)/
	git update-ref refs/heads/website-updates/www HEAD

upload-htmldoc:
	$(MAKE) htmldoc SPHINXOPTS='-D html_theme=pymvpa_online'
	chmod a+rX -R $(HTML_DIR)
	rsync $(RSYNC_OPTS_UP) $(HTML_DIR)/* $(WWW_UPLOAD_URI)/
	git update-ref refs/heads/website-updates/www-html HEAD

upload-website-dev:
	sed -i -e "s,http://disqus.com/forums/pymvpa/,http://disqus.com/forums/pymvpa-dev/,g" \
		-e "s,^<!-- HEADNOTES -->,<!-- HEADNOTES --><div class='admonition note'>This content refers to an unreleased development version of PyMVPA</div>,g" \
		doc/source/_themes/pymvpa_online/page.html
	$(MAKE) website SPHINXOPTS='-D html_theme=pymvpa_online'
	sed -i -e "s,http://disqus.com/forums/pymvpa-dev/,http://disqus.com/forums/pymvpa/,g" \
		-e "s,^<!-- HEADNOTES -->.*$$,<!-- HEADNOTES -->,g" \
		doc/source/_themes/pymvpa_online/page.html
	sed -i -e "s,www.pymvpa.org,dev.pymvpa.org,g" $(WWW_DIR)/sitemap.xml
	chmod a+rX -R $(WWW_DIR)
	rsync $(RSYNC_OPTS_UP) $(WWW_DIR)/* $(WWW_UPLOAD_URI_DEV)/

upload-htmldoc-dev:
	grep -q pymvpa-dev doc/source/_themes/pymvpa_online/page.html || \
	 sed -i -e "s,http://disqus.com/forums/pymvpa/,http://disqus.com/forums/pymvpa-dev/,g" \
		-e "s,^<!-- HEADNOTES -->,<!-- HEADNOTES --><div class='admonition note'>This content refers to an unreleased development version of PyMVPA</div>,g" \
		doc/source/_themes/pymvpa_online/page.html
	$(MAKE) htmldoc SPHINXOPTS='-D html_theme=pymvpa_online'
	sed -i -e "s,http://disqus.com/forums/pymvpa-dev/,http://disqus.com/forums/pymvpa/,g" \
		-e "s,^<!-- HEADNOTES -->.*$$,<!-- HEADNOTES -->,g" \
		doc/source/_themes/pymvpa_online/page.html
	rsync $(RSYNC_OPTS_UP) $(HTML_DIR)/* $(WWW_UPLOAD_URI_DEV)/


# upload plain .rst files as descriptions to data.pympa.org as descriptions of
# each dataset
upload-datadb-descriptions:
	for ds in doc/source/datadb/*; do \
		ds=$$(basename $${ds}); ds=$${ds%*.rst}; \
		scp doc/source/datadb/$${ds}.rst $(DATA_UPLOAD_URI)/$${ds}/README.rst; \
	done

#
# Tests (unittests, docs, examples)
#

ut-%: build
	@cd $(TEST_DIR) && PYTHONPATH=$(LPYTHONPATH) $(NOSETESTS) --nocapture mvpa2/tests/test_$*.py

unittest: build
	@echo "I: Running unittests (without optimization nor debug output)"
	@cd $(TEST_DIR) && $(MPLPYTHON) mvpa2/tests/__init__.py


# test if PyMVPA is working if optional externals are missing
unittest-badexternals: build

=== debian/changelog ===
pymvpa2 (2.6.5-1~nd+1) sid; urgency=medium

  * Backported for sid.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Tue, 26 Jun 2018 19:39:54 -0400

pymvpa2 (2.6.5-1) unstable; urgency=medium

  * Fresh minor upstream release
  * debian/patches
    - two patches to make docs buildable (Closes: #896628)

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 25 Jun 2018 22:03:05 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: pymvpa2
 Section: python
 Priority: optional
-Maintainer: NeuroDebian team <team@neuro.debian.net>
+Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
+X-Original-Maintainer: NeuroDebian team <team@neuro.debian.net>
 Uploaders: Michael Hanke <mih@debian.org>, Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends: debhelper (>= 9~),
                dh-python,
@@ -15,6 +16,7 @@
                libsvm-dev (>= 2.84.0),
                help2man, man2html,
                python-sphinx, python-numpydoc,
+               latexmk,
                graphviz, inkscape, imagemagick, bc,
                python-matplotlib,
                python-statsmodels [!s390x],
@@ -29,7 +31,7 @@
 
 Package: python-mvpa2
 Architecture: all
-Depends: ${misc:Depends}, ${python:Depends},
+Depends: neurodebian-popularity-contest, ${misc:Depends}, ${python:Depends},
          python-mvpa2-lib(>= ${source:Version}),
          python-numpy,
 Recommends:
@@ -78,7 +80,7 @@
 
 Package: python-mvpa2-lib
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends},
+Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}, ${python:Depends},
          python-numpy
 Provides: ${python:Provides}
 XB-Python-Version: ${python:Versions}
@@ -94,7 +96,7 @@
 Package: python-mvpa2-doc
 Architecture: all
 Section: doc
-Depends: ${misc:Depends}, libjs-jquery, libjs-underscore
+Depends: neurodebian-popularity-contest, ${misc:Depends}, libjs-jquery, libjs-underscore
 Suggests: python-mvpa2, python-mvpa2-tutorialdata, ipython-notebook
 Description: documentation and examples for PyMVPA v. 2
  This is an add-on package for the PyMVPA framework. It provides a
